<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'CHANGE_INFOType' => '\\StructType\\CHANGE_INFOType',
            'AMOUNTType' => '\\StructType\\AMOUNTType_1',
            'VALIDITY_PERIODType' => '\\StructType\\VALIDITY_PERIODType',
            'ENTITYType' => '\\StructType\\ENTITYType',
            'FILEType' => '\\StructType\\FILEType',
            'CREATE_USER_INFO' => '\\StructType\\CREATE_USER_INFO',
            'FILESETType' => '\\StructType\\FILESETType',
            'COMMENTType' => '\\StructType\\COMMENTType',
            'COMMENTSETType' => '\\StructType\\COMMENTSETType',
            'SEARCH_KEYType' => '\\StructType\\SEARCH_KEYType',
            'SEARCH_RESULTType' => '\\StructType\\SEARCH_RESULTType',
            'FIND_KEYType' => '\\StructType\\FIND_KEYType',
            'LOV_VALUEType' => '\\StructType\\LOV_VALUEType',
            'ISO_CURRENCY_CODEType' => '\\StructType\\ISO_CURRENCY_CODEType',
            'ATTRIBUTESTYPE' => '\\StructType\\ATTRIBUTESTYPE',
            'ENTITYBaseType' => '\\StructType\\ENTITYBaseType',
            'REQUEST_HEADERType' => '\\StructType\\REQUEST_HEADERType',
            'REQUEST_RETURNType' => '\\StructType\\REQUEST_RETURNType',
            'REQUEST_ERRORType' => '\\StructType\\REQUEST_ERRORType',
            'REQUEST_INFOType' => '\\StructType\\REQUEST_INFOType',
            'base64Binary' => '\\StructType\\Base64Binary',
            'hexBinary' => '\\StructType\\HexBinary',
            'SignatureType' => '\\StructType\\SignatureType',
            'SignatureValueType' => '\\StructType\\SignatureValueType',
            'SignedInfoType' => '\\StructType\\SignedInfoType',
            'CanonicalizationMethodType' => '\\StructType\\CanonicalizationMethodType',
            'SignatureMethodType' => '\\StructType\\SignatureMethodType',
            'ReferenceType' => '\\StructType\\ReferenceType',
            'TransformsType' => '\\StructType\\TransformsType',
            'TransformType' => '\\StructType\\TransformType',
            'DigestMethodType' => '\\StructType\\DigestMethodType',
            'KeyInfoType' => '\\StructType\\KeyInfoType',
            'KeyValueType' => '\\StructType\\KeyValueType',
            'RetrievalMethodType' => '\\StructType\\RetrievalMethodType',
            'X509DataType' => '\\StructType\\X509DataType',
            'X509IssuerSerialType' => '\\StructType\\X509IssuerSerialType',
            'PGPDataType' => '\\StructType\\PGPDataType',
            'SPKIDataType' => '\\StructType\\SPKIDataType',
            'ObjectType' => '\\StructType\\ObjectType',
            'ManifestType' => '\\StructType\\ManifestType',
            'SignaturePropertiesType' => '\\StructType\\SignaturePropertiesType',
            'SignaturePropertyType' => '\\StructType\\SignaturePropertyType',
            'DSAKeyValueType' => '\\StructType\\DSAKeyValueType',
            'RSAKeyValueType' => '\\StructType\\RSAKeyValueType',
            'AnyType' => '\\StructType\\AnyType',
            'ObjectIdentifierType' => '\\StructType\\ObjectIdentifierType',
            'IdentifierType' => '\\StructType\\IdentifierType',
            'DocumentationReferencesType' => '\\StructType\\DocumentationReferencesType',
            'EncapsulatedPKIDataType' => '\\StructType\\EncapsulatedPKIDataType',
            'IncludeType' => '\\StructType\\IncludeType',
            'ReferenceInfoType' => '\\StructType\\ReferenceInfoType',
            'GenericTimeStampType' => '\\StructType\\GenericTimeStampType',
            'XAdESTimeStampType' => '\\StructType\\XAdESTimeStampType',
            'OtherTimeStampType' => '\\StructType\\OtherTimeStampType',
            'QualifyingPropertiesType' => '\\StructType\\QualifyingPropertiesType',
            'SignedPropertiesType' => '\\StructType\\SignedPropertiesType',
            'UnsignedPropertiesType' => '\\StructType\\UnsignedPropertiesType',
            'SignedSignaturePropertiesType' => '\\StructType\\SignedSignaturePropertiesType',
            'SignedDataObjectPropertiesType' => '\\StructType\\SignedDataObjectPropertiesType',
            'UnsignedSignaturePropertiesType' => '\\StructType\\UnsignedSignaturePropertiesType',
            'UnsignedDataObjectPropertiesType' => '\\StructType\\UnsignedDataObjectPropertiesType',
            'QualifyingPropertiesReferenceType' => '\\StructType\\QualifyingPropertiesReferenceType',
            'CertIDListType' => '\\StructType\\CertIDListType',
            'CertIDType' => '\\StructType\\CertIDType',
            'DigestAlgAndValueType' => '\\StructType\\DigestAlgAndValueType',
            'SignaturePolicyIdentifierType' => '\\StructType\\SignaturePolicyIdentifierType',
            'SignaturePolicyIdType' => '\\StructType\\SignaturePolicyIdType',
            'SigPolicyQualifiersListType' => '\\StructType\\SigPolicyQualifiersListType',
            'SPUserNoticeType' => '\\StructType\\SPUserNoticeType',
            'NoticeReferenceType' => '\\StructType\\NoticeReferenceType',
            'IntegerListType' => '\\StructType\\IntegerListType',
            'CounterSignatureType' => '\\StructType\\CounterSignatureType',
            'DataObjectFormatType' => '\\StructType\\DataObjectFormatType',
            'CommitmentTypeIndicationType' => '\\StructType\\CommitmentTypeIndicationType',
            'CommitmentTypeQualifiersListType' => '\\StructType\\CommitmentTypeQualifiersListType',
            'SignatureProductionPlaceType' => '\\StructType\\SignatureProductionPlaceType',
            'SignerRoleType' => '\\StructType\\SignerRoleType',
            'ClaimedRolesListType' => '\\StructType\\ClaimedRolesListType',
            'CertifiedRolesListType' => '\\StructType\\CertifiedRolesListType',
            'CompleteCertificateRefsType' => '\\StructType\\CompleteCertificateRefsType',
            'CompleteRevocationRefsType' => '\\StructType\\CompleteRevocationRefsType',
            'CRLRefsType' => '\\StructType\\CRLRefsType',
            'CRLRefType' => '\\StructType\\CRLRefType',
            'CRLIdentifierType' => '\\StructType\\CRLIdentifierType',
            'OCSPRefsType' => '\\StructType\\OCSPRefsType',
            'OCSPRefType' => '\\StructType\\OCSPRefType',
            'ResponderIDType' => '\\StructType\\ResponderIDType',
            'OCSPIdentifierType' => '\\StructType\\OCSPIdentifierType',
            'OtherCertStatusRefsType' => '\\StructType\\OtherCertStatusRefsType',
            'CertificateValuesType' => '\\StructType\\CertificateValuesType',
            'RevocationValuesType' => '\\StructType\\RevocationValuesType',
            'CRLValuesType' => '\\StructType\\CRLValuesType',
            'OCSPValuesType' => '\\StructType\\OCSPValuesType',
            'OtherCertStatusValuesType' => '\\StructType\\OtherCertStatusValuesType',
            'ValidationDataType' => '\\StructType\\ValidationDataType',
            'faturaType' => '\\StructType\\FaturaType',
            'vergiBilgisi' => '\\StructType\\VergiBilgisi',
            'vergi' => '\\StructType\\Vergi',
            'tevkifat' => '\\StructType\\Tevkifat',
            'internetSatisBilgi' => '\\StructType\\InternetSatisBilgi',
            'gonderiBilgileri' => '\\StructType\\GonderiBilgileri',
            'ynOkcFisBilgisi' => '\\StructType\\YnOkcFisBilgisi',
            'faturaIptalType' => '\\StructType\\FaturaIptalType',
            'eArsivRaporu' => '\\StructType\\EArsivRaporu',
            'baslikType' => '\\StructType\\BaslikType',
            'vknTcknType' => '\\StructType\\VknTcknType',
            'kisiType' => '\\StructType\\KisiType',
            'tuzelKisi' => '\\StructType\\TuzelKisi',
            'gercekKisi' => '\\StructType\\GercekKisi',
            'aliciType' => '\\StructType\\AliciType',
            'OIBOperation' => '\\StructType\\OIBOperation',
            'RequestFaultType' => '\\StructType\\RequestFaultType',
            'ArchiveInvoiceWriteRequest' => '\\StructType\\ArchiveInvoiceWriteRequest',
            'ArchiveInvoiceWriteContent' => '\\StructType\\ArchiveInvoiceWriteContent',
            'Elements' => '\\StructType\\Elements',
            'ArchiveInvoiceWriteResponse' => '\\StructType\\ArchiveInvoiceWriteResponse',
            'ArchiveInvoiceReadRequest' => '\\StructType\\ArchiveInvoiceReadRequest',
            'ArchiveInvoiceReadResponse' => '\\StructType\\ArchiveInvoiceReadResponse',
            'ArchiveInvoiceCopyRequest' => '\\StructType\\ArchiveInvoiceCopyRequest',
            'ArchiveInvoiceCopyResponse' => '\\StructType\\ArchiveInvoiceCopyResponse',
            'ArchiveGetInvoiceInfoRequest' => '\\StructType\\ArchiveGetInvoiceInfoRequest',
            'ArchiveGetInvoiceInfoResponse' => '\\StructType\\ArchiveGetInvoiceInfoResponse',
            'INVOICE' => '\\StructType\\INVOICE',
            'HEADER' => '\\StructType\\HEADER',
            'GetEArchiveInvoiceStatusRequest' => '\\StructType\\GetEArchiveInvoiceStatusRequest',
            'GetEArchiveInvoiceStatusResponse' => '\\StructType\\GetEArchiveInvoiceStatusResponse',
            'EARCHIVE_INVOICE' => '\\StructType\\EARCHIVE_INVOICE',
            'ArchiveInvoiceExtendedRequest' => '\\StructType\\ArchiveInvoiceExtendedRequest',
            'ArchiveInvoiceExtendedContent' => '\\StructType\\ArchiveInvoiceExtendedContent',
            'INVOICE_PROPERTIES' => '\\StructType\\INVOICE_PROPERTIES',
            'EARSIV_PROPERTIES' => '\\StructType\\EARSIV_PROPERTIES',
            'PDF_PROPERTIES' => '\\StructType\\PDF_PROPERTIES',
            'ArchiveInvoiceExtendedResponse' => '\\StructType\\ArchiveInvoiceExtendedResponse',
            'ArchiveGenericDocumentRequest' => '\\StructType\\ArchiveGenericDocumentRequest',
            'GENERIC_CONTENT' => '\\StructType\\GENERIC_CONTENT',
            'ArchiveGenericDocumentResponse' => '\\StructType\\ArchiveGenericDocumentResponse',
            'GenericReadRequest' => '\\StructType\\GenericReadRequest',
            'DOCUMENT' => '\\StructType\\DOCUMENT',
            'GenericReadResponse' => '\\StructType\\GenericReadResponse',
            'ReadEArchiveReportRequest' => '\\StructType\\ReadEArchiveReportRequest',
            'ReadEArchiveReportResponse' => '\\StructType\\ReadEArchiveReportResponse',
            'CancelEArchiveInvoiceRequest' => '\\StructType\\CancelEArchiveInvoiceRequest',
            'CancelEArsivInvoiceContent' => '\\StructType\\CancelEArsivInvoiceContent',
            'CancelEArchiveInvoiceResponse' => '\\StructType\\CancelEArchiveInvoiceResponse',
            'GetEArchiveReportRequest' => '\\StructType\\GetEArchiveReportRequest',
            'GetEArchiveReportResponse' => '\\StructType\\GetEArchiveReportResponse',
            'REPORT_INVOICE' => '\\StructType\\REPORT_INVOICE',
            'REPORT' => '\\StructType\\REPORT',
            'GetEArchiveInvoiceRequest' => '\\StructType\\GetEArchiveInvoiceRequest',
            'GetEArchiveInvoiceResponse' => '\\StructType\\GetEArchiveInvoiceResponse',
            'CancelEDefterRequest' => '\\StructType\\CancelEDefterRequest',
            'CancelEDefterContent' => '\\StructType\\CancelEDefterContent',
            'CancelEDefterResponse' => '\\StructType\\CancelEDefterResponse',
            'GetGenericArchiveByPeriodRequest' => '\\StructType\\GetGenericArchiveByPeriodRequest',
            'GetGenericArchiveByPeriodResponse' => '\\StructType\\GetGenericArchiveByPeriodResponse',
            'GetGenericArchiveStatusRequest' => '\\StructType\\GetGenericArchiveStatusRequest',
            'GetGenericArchiveStatusResponse' => '\\StructType\\GetGenericArchiveStatusResponse',
            'GetEmailEarchiveInvoiceRequest' => '\\StructType\\GetEmailEarchiveInvoiceRequest',
            'GetEmailEarchiveInvoiceResponse' => '\\StructType\\GetEmailEarchiveInvoiceResponse',
            'SendSmsEarchiveInvoiceRequest' => '\\StructType\\SendSmsEarchiveInvoiceRequest',
            'SendSmsEarchiveInvoiceResponse' => '\\StructType\\SendSmsEarchiveInvoiceResponse',
            'GetEArchiveInvoiceListRequest' => '\\StructType\\GetEArchiveInvoiceListRequest',
            'GetEArchiveInvoiceListResponse' => '\\StructType\\GetEArchiveInvoiceListResponse',
            'EARCHIVEINV' => '\\StructType\\EARCHIVEINV',
            'MarkEArchiveInvoiceRequest' => '\\StructType\\MarkEArchiveInvoiceRequest',
            'MARK' => '\\StructType\\MARK',
            'MarkEArchiveInvoiceResponse' => '\\StructType\\MarkEArchiveInvoiceResponse',
            'EArchiveInvoiceCountRequest' => '\\StructType\\EArchiveInvoiceCountRequest',
            'EArchiveInvoiceCountResponse' => '\\StructType\\EArchiveInvoiceCountResponse',
        );
    }
}
