<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AMOUNTType StructType
 * Meta informations extracted from the WSDL
 * - documentation: Helper Entity; Contains price type
 * @subpackage Structs
 */
class AMOUNTType_1 extends AbstractStructBase
{
    /**
     * The AMOUNT
     * Meta informations extracted from the WSDL
     * - documentation: Charge amount.
     * @var float
     */
    public $AMOUNT;
    /**
     * The CURRENCY_CODE
     * Meta informations extracted from the WSDL
     * - documentation: See ISO_CURRENCY_CODE Type
     * - minOccurs: 0
     * @var \StructType\ISO_CURRENCY_CODEType
     */
    public $CURRENCY_CODE;
    /**
     * Constructor method for AMOUNTType
     * @uses AMOUNTType_1::setAMOUNT()
     * @uses AMOUNTType_1::setCURRENCY_CODE()
     * @param float $aMOUNT
     * @param \StructType\ISO_CURRENCY_CODEType $cURRENCY_CODE
     */
    public function __construct($aMOUNT = null, \StructType\ISO_CURRENCY_CODEType $cURRENCY_CODE = null)
    {
        $this
            ->setAMOUNT($aMOUNT)
            ->setCURRENCY_CODE($cURRENCY_CODE);
    }
    /**
     * Get AMOUNT value
     * @return float|null
     */
    public function getAMOUNT()
    {
        return $this->AMOUNT;
    }
    /**
     * Set AMOUNT value
     * @param float $aMOUNT
     * @return \StructType\AMOUNTType_1
     */
    public function setAMOUNT($aMOUNT = null)
    {
        $this->AMOUNT = $aMOUNT;
        return $this;
    }
    /**
     * Get CURRENCY_CODE value
     * @return \StructType\ISO_CURRENCY_CODEType|null
     */
    public function getCURRENCY_CODE()
    {
        return $this->CURRENCY_CODE;
    }
    /**
     * Set CURRENCY_CODE value
     * @param \StructType\ISO_CURRENCY_CODEType $cURRENCY_CODE
     * @return \StructType\AMOUNTType_1
     */
    public function setCURRENCY_CODE(\StructType\ISO_CURRENCY_CODEType $cURRENCY_CODE = null)
    {
        $this->CURRENCY_CODE = $cURRENCY_CODE;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AMOUNTType_1
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
