<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ArchiveInvoiceExtendedContent StructType
 * @subpackage Structs
 */
class ArchiveInvoiceExtendedContent extends AbstractStructBase
{
    /**
     * The INVOICE_PROPERTIES
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \StructType\INVOICE_PROPERTIES[]
     */
    public $INVOICE_PROPERTIES;
    /**
     * Constructor method for ArchiveInvoiceExtendedContent
     * @uses ArchiveInvoiceExtendedContent::setINVOICE_PROPERTIES()
     * @param \StructType\INVOICE_PROPERTIES[] $iNVOICE_PROPERTIES
     */
    public function __construct(array $iNVOICE_PROPERTIES = array())
    {
        $this
            ->setINVOICE_PROPERTIES($iNVOICE_PROPERTIES);
    }
    /**
     * Get INVOICE_PROPERTIES value
     * @return \StructType\INVOICE_PROPERTIES[]
     */
    public function getINVOICE_PROPERTIES()
    {
        return $this->INVOICE_PROPERTIES;
    }
    /**
     * Set INVOICE_PROPERTIES value
     * @throws \InvalidArgumentException
     * @param \StructType\INVOICE_PROPERTIES[] $iNVOICE_PROPERTIES
     * @return \StructType\ArchiveInvoiceExtendedContent
     */
    public function setINVOICE_PROPERTIES(array $iNVOICE_PROPERTIES = array())
    {
        foreach ($iNVOICE_PROPERTIES as $archiveInvoiceExtendedContentINVOICE_PROPERTIESItem) {
            // validation for constraint: itemType
            if (!$archiveInvoiceExtendedContentINVOICE_PROPERTIESItem instanceof \StructType\INVOICE_PROPERTIES) {
                throw new \InvalidArgumentException(sprintf('The INVOICE_PROPERTIES property can only contain items of \StructType\INVOICE_PROPERTIES, "%s" given', is_object($archiveInvoiceExtendedContentINVOICE_PROPERTIESItem) ? get_class($archiveInvoiceExtendedContentINVOICE_PROPERTIESItem) : gettype($archiveInvoiceExtendedContentINVOICE_PROPERTIESItem)), __LINE__);
            }
        }
        $this->INVOICE_PROPERTIES = $iNVOICE_PROPERTIES;
        return $this;
    }
    /**
     * Add item to INVOICE_PROPERTIES value
     * @throws \InvalidArgumentException
     * @param \StructType\INVOICE_PROPERTIES $item
     * @return \StructType\ArchiveInvoiceExtendedContent
     */
    public function addToINVOICE_PROPERTIES(\StructType\INVOICE_PROPERTIES $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\INVOICE_PROPERTIES) {
            throw new \InvalidArgumentException(sprintf('The INVOICE_PROPERTIES property can only contain items of \StructType\INVOICE_PROPERTIES, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->INVOICE_PROPERTIES[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ArchiveInvoiceExtendedContent
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
