<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CRLRefsType StructType
 * @subpackage Structs
 */
class CRLRefsType extends AbstractStructBase
{
    /**
     * The CRLRef
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\CRLRefType[]
     */
    public $CRLRef;
    /**
     * Constructor method for CRLRefsType
     * @uses CRLRefsType::setCRLRef()
     * @param \StructType\CRLRefType[] $cRLRef
     */
    public function __construct(array $cRLRef = array())
    {
        $this
            ->setCRLRef($cRLRef);
    }
    /**
     * Get CRLRef value
     * @return \StructType\CRLRefType[]|null
     */
    public function getCRLRef()
    {
        return $this->CRLRef;
    }
    /**
     * Set CRLRef value
     * @throws \InvalidArgumentException
     * @param \StructType\CRLRefType[] $cRLRef
     * @return \StructType\CRLRefsType
     */
    public function setCRLRef(array $cRLRef = array())
    {
        foreach ($cRLRef as $cRLRefsTypeCRLRefItem) {
            // validation for constraint: itemType
            if (!$cRLRefsTypeCRLRefItem instanceof \StructType\CRLRefType) {
                throw new \InvalidArgumentException(sprintf('The CRLRef property can only contain items of \StructType\CRLRefType, "%s" given', is_object($cRLRefsTypeCRLRefItem) ? get_class($cRLRefsTypeCRLRefItem) : gettype($cRLRefsTypeCRLRefItem)), __LINE__);
            }
        }
        $this->CRLRef = $cRLRef;
        return $this;
    }
    /**
     * Add item to CRLRef value
     * @throws \InvalidArgumentException
     * @param \StructType\CRLRefType $item
     * @return \StructType\CRLRefsType
     */
    public function addToCRLRef(\StructType\CRLRefType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CRLRefType) {
            throw new \InvalidArgumentException(sprintf('The CRLRef property can only contain items of \StructType\CRLRefType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CRLRef[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CRLRefsType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
