<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CancelEArsivInvoiceContent StructType
 * @subpackage Structs
 */
class CancelEArsivInvoiceContent extends AbstractStructBase
{
    /**
     * The FATURA_UUID
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $FATURA_UUID;
    /**
     * The UPLOAD_FLAG
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $UPLOAD_FLAG;
    /**
     * The FATURA_ID
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $FATURA_ID;
    /**
     * The EARSIV_CANCEL_EMAIL
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $EARSIV_CANCEL_EMAIL;
    /**
     * The DELETE_FLAG
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $DELETE_FLAG;
    /**
     * The IPTAL_TARIHI
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $IPTAL_TARIHI;
    /**
     * The TOPLAM_TUTAR
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $TOPLAM_TUTAR;
    /**
     * The INVOICE_CONTENT
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Base64Binary
     */
    public $INVOICE_CONTENT;
    /**
     * Constructor method for CancelEArsivInvoiceContent
     * @uses CancelEArsivInvoiceContent::setFATURA_UUID()
     * @uses CancelEArsivInvoiceContent::setUPLOAD_FLAG()
     * @uses CancelEArsivInvoiceContent::setFATURA_ID()
     * @uses CancelEArsivInvoiceContent::setEARSIV_CANCEL_EMAIL()
     * @uses CancelEArsivInvoiceContent::setDELETE_FLAG()
     * @uses CancelEArsivInvoiceContent::setIPTAL_TARIHI()
     * @uses CancelEArsivInvoiceContent::setTOPLAM_TUTAR()
     * @uses CancelEArsivInvoiceContent::setINVOICE_CONTENT()
     * @param string $fATURA_UUID
     * @param string $uPLOAD_FLAG
     * @param string $fATURA_ID
     * @param string $eARSIV_CANCEL_EMAIL
     * @param string $dELETE_FLAG
     * @param string $iPTAL_TARIHI
     * @param float $tOPLAM_TUTAR
     * @param \StructType\Base64Binary $iNVOICE_CONTENT
     */
    public function __construct($fATURA_UUID = null, $uPLOAD_FLAG = null, $fATURA_ID = null, $eARSIV_CANCEL_EMAIL = null, $dELETE_FLAG = null, $iPTAL_TARIHI = null, $tOPLAM_TUTAR = null, \StructType\Base64Binary $iNVOICE_CONTENT = null)
    {
        $this
            ->setFATURA_UUID($fATURA_UUID)
            ->setUPLOAD_FLAG($uPLOAD_FLAG)
            ->setFATURA_ID($fATURA_ID)
            ->setEARSIV_CANCEL_EMAIL($eARSIV_CANCEL_EMAIL)
            ->setDELETE_FLAG($dELETE_FLAG)
            ->setIPTAL_TARIHI($iPTAL_TARIHI)
            ->setTOPLAM_TUTAR($tOPLAM_TUTAR)
            ->setINVOICE_CONTENT($iNVOICE_CONTENT);
    }
    /**
     * Get FATURA_UUID value
     * @return string
     */
    public function getFATURA_UUID()
    {
        return $this->FATURA_UUID;
    }
    /**
     * Set FATURA_UUID value
     * @param string $fATURA_UUID
     * @return \StructType\CancelEArsivInvoiceContent
     */
    public function setFATURA_UUID($fATURA_UUID = null)
    {
        // validation for constraint: string
        if (!is_null($fATURA_UUID) && !is_string($fATURA_UUID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fATURA_UUID)), __LINE__);
        }
        $this->FATURA_UUID = $fATURA_UUID;
        return $this;
    }
    /**
     * Get UPLOAD_FLAG value
     * @return string|null
     */
    public function getUPLOAD_FLAG()
    {
        return $this->UPLOAD_FLAG;
    }
    /**
     * Set UPLOAD_FLAG value
     * @uses \EnumType\FLAG_VALUE::valueIsValid()
     * @uses \EnumType\FLAG_VALUE::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $uPLOAD_FLAG
     * @return \StructType\CancelEArsivInvoiceContent
     */
    public function setUPLOAD_FLAG($uPLOAD_FLAG = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\FLAG_VALUE::valueIsValid($uPLOAD_FLAG)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $uPLOAD_FLAG, implode(', ', \EnumType\FLAG_VALUE::getValidValues())), __LINE__);
        }
        $this->UPLOAD_FLAG = $uPLOAD_FLAG;
        return $this;
    }
    /**
     * Get FATURA_ID value
     * @return string|null
     */
    public function getFATURA_ID()
    {
        return $this->FATURA_ID;
    }
    /**
     * Set FATURA_ID value
     * @param string $fATURA_ID
     * @return \StructType\CancelEArsivInvoiceContent
     */
    public function setFATURA_ID($fATURA_ID = null)
    {
        // validation for constraint: string
        if (!is_null($fATURA_ID) && !is_string($fATURA_ID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fATURA_ID)), __LINE__);
        }
        $this->FATURA_ID = $fATURA_ID;
        return $this;
    }
    /**
     * Get EARSIV_CANCEL_EMAIL value
     * @return string|null
     */
    public function getEARSIV_CANCEL_EMAIL()
    {
        return $this->EARSIV_CANCEL_EMAIL;
    }
    /**
     * Set EARSIV_CANCEL_EMAIL value
     * @param string $eARSIV_CANCEL_EMAIL
     * @return \StructType\CancelEArsivInvoiceContent
     */
    public function setEARSIV_CANCEL_EMAIL($eARSIV_CANCEL_EMAIL = null)
    {
        // validation for constraint: string
        if (!is_null($eARSIV_CANCEL_EMAIL) && !is_string($eARSIV_CANCEL_EMAIL)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($eARSIV_CANCEL_EMAIL)), __LINE__);
        }
        $this->EARSIV_CANCEL_EMAIL = $eARSIV_CANCEL_EMAIL;
        return $this;
    }
    /**
     * Get DELETE_FLAG value
     * @return string|null
     */
    public function getDELETE_FLAG()
    {
        return $this->DELETE_FLAG;
    }
    /**
     * Set DELETE_FLAG value
     * @param string $dELETE_FLAG
     * @return \StructType\CancelEArsivInvoiceContent
     */
    public function setDELETE_FLAG($dELETE_FLAG = null)
    {
        // validation for constraint: string
        if (!is_null($dELETE_FLAG) && !is_string($dELETE_FLAG)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dELETE_FLAG)), __LINE__);
        }
        $this->DELETE_FLAG = $dELETE_FLAG;
        return $this;
    }
    /**
     * Get IPTAL_TARIHI value
     * @return string|null
     */
    public function getIPTAL_TARIHI()
    {
        return $this->IPTAL_TARIHI;
    }
    /**
     * Set IPTAL_TARIHI value
     * @param string $iPTAL_TARIHI
     * @return \StructType\CancelEArsivInvoiceContent
     */
    public function setIPTAL_TARIHI($iPTAL_TARIHI = null)
    {
        // validation for constraint: string
        if (!is_null($iPTAL_TARIHI) && !is_string($iPTAL_TARIHI)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($iPTAL_TARIHI)), __LINE__);
        }
        $this->IPTAL_TARIHI = $iPTAL_TARIHI;
        return $this;
    }
    /**
     * Get TOPLAM_TUTAR value
     * @return float|null
     */
    public function getTOPLAM_TUTAR()
    {
        return $this->TOPLAM_TUTAR;
    }
    /**
     * Set TOPLAM_TUTAR value
     * @param float $tOPLAM_TUTAR
     * @return \StructType\CancelEArsivInvoiceContent
     */
    public function setTOPLAM_TUTAR($tOPLAM_TUTAR = null)
    {
        $this->TOPLAM_TUTAR = $tOPLAM_TUTAR;
        return $this;
    }
    /**
     * Get INVOICE_CONTENT value
     * @return \StructType\Base64Binary|null
     */
    public function getINVOICE_CONTENT()
    {
        return $this->INVOICE_CONTENT;
    }
    /**
     * Set INVOICE_CONTENT value
     * @param \StructType\Base64Binary $iNVOICE_CONTENT
     * @return \StructType\CancelEArsivInvoiceContent
     */
    public function setINVOICE_CONTENT(\StructType\Base64Binary $iNVOICE_CONTENT = null)
    {
        $this->INVOICE_CONTENT = $iNVOICE_CONTENT;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CancelEArsivInvoiceContent
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
