<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CompleteRevocationRefsType StructType
 * @subpackage Structs
 */
class CompleteRevocationRefsType extends AbstractStructBase
{
    /**
     * The CRLRefs
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CRLRefsType
     */
    public $CRLRefs;
    /**
     * The OCSPRefs
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\OCSPRefsType
     */
    public $OCSPRefs;
    /**
     * The OtherRefs
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\OtherCertStatusRefsType
     */
    public $OtherRefs;
    /**
     * The Id
     * Meta informations extracted from the WSDL
     * - use: optional
     * @var string
     */
    public $Id;
    /**
     * Constructor method for CompleteRevocationRefsType
     * @uses CompleteRevocationRefsType::setCRLRefs()
     * @uses CompleteRevocationRefsType::setOCSPRefs()
     * @uses CompleteRevocationRefsType::setOtherRefs()
     * @uses CompleteRevocationRefsType::setId()
     * @param \StructType\CRLRefsType $cRLRefs
     * @param \StructType\OCSPRefsType $oCSPRefs
     * @param \StructType\OtherCertStatusRefsType $otherRefs
     * @param string $id
     */
    public function __construct(\StructType\CRLRefsType $cRLRefs = null, \StructType\OCSPRefsType $oCSPRefs = null, \StructType\OtherCertStatusRefsType $otherRefs = null, $id = null)
    {
        $this
            ->setCRLRefs($cRLRefs)
            ->setOCSPRefs($oCSPRefs)
            ->setOtherRefs($otherRefs)
            ->setId($id);
    }
    /**
     * Get CRLRefs value
     * @return \StructType\CRLRefsType|null
     */
    public function getCRLRefs()
    {
        return $this->CRLRefs;
    }
    /**
     * Set CRLRefs value
     * @param \StructType\CRLRefsType $cRLRefs
     * @return \StructType\CompleteRevocationRefsType
     */
    public function setCRLRefs(\StructType\CRLRefsType $cRLRefs = null)
    {
        $this->CRLRefs = $cRLRefs;
        return $this;
    }
    /**
     * Get OCSPRefs value
     * @return \StructType\OCSPRefsType|null
     */
    public function getOCSPRefs()
    {
        return $this->OCSPRefs;
    }
    /**
     * Set OCSPRefs value
     * @param \StructType\OCSPRefsType $oCSPRefs
     * @return \StructType\CompleteRevocationRefsType
     */
    public function setOCSPRefs(\StructType\OCSPRefsType $oCSPRefs = null)
    {
        $this->OCSPRefs = $oCSPRefs;
        return $this;
    }
    /**
     * Get OtherRefs value
     * @return \StructType\OtherCertStatusRefsType|null
     */
    public function getOtherRefs()
    {
        return $this->OtherRefs;
    }
    /**
     * Set OtherRefs value
     * @param \StructType\OtherCertStatusRefsType $otherRefs
     * @return \StructType\CompleteRevocationRefsType
     */
    public function setOtherRefs(\StructType\OtherCertStatusRefsType $otherRefs = null)
    {
        $this->OtherRefs = $otherRefs;
        return $this;
    }
    /**
     * Get Id value
     * @return string|null
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param string $id
     * @return \StructType\CompleteRevocationRefsType
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($id)), __LINE__);
        }
        $this->Id = $id;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CompleteRevocationRefsType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
