<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EArchiveInvoiceCountRequest StructType
 * Meta informations extracted from the WSDL
 * - type: EArchiveInvoiceCountRequest
 * @subpackage Structs
 */
class EArchiveInvoiceCountRequest extends AbstractStructBase
{
    /**
     * The REQUEST_HEADER
     * @var \StructType\REQUEST_HEADERType
     */
    public $REQUEST_HEADER;
    /**
     * The ISSUE_DATE_START
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ISSUE_DATE_START;
    /**
     * The ISSUE_DATE_END
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ISSUE_DATE_END;
    /**
     * The CDATE_START
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $CDATE_START;
    /**
     * The CDATE_END
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $CDATE_END;
    /**
     * Constructor method for EArchiveInvoiceCountRequest
     * @uses EArchiveInvoiceCountRequest::setREQUEST_HEADER()
     * @uses EArchiveInvoiceCountRequest::setISSUE_DATE_START()
     * @uses EArchiveInvoiceCountRequest::setISSUE_DATE_END()
     * @uses EArchiveInvoiceCountRequest::setCDATE_START()
     * @uses EArchiveInvoiceCountRequest::setCDATE_END()
     * @param \StructType\REQUEST_HEADERType $rEQUEST_HEADER
     * @param string $iSSUE_DATE_START
     * @param string $iSSUE_DATE_END
     * @param string $cDATE_START
     * @param string $cDATE_END
     */
    public function __construct(\StructType\REQUEST_HEADERType $rEQUEST_HEADER = null, $iSSUE_DATE_START = null, $iSSUE_DATE_END = null, $cDATE_START = null, $cDATE_END = null)
    {
        $this
            ->setREQUEST_HEADER($rEQUEST_HEADER)
            ->setISSUE_DATE_START($iSSUE_DATE_START)
            ->setISSUE_DATE_END($iSSUE_DATE_END)
            ->setCDATE_START($cDATE_START)
            ->setCDATE_END($cDATE_END);
    }
    /**
     * Get REQUEST_HEADER value
     * @return \StructType\REQUEST_HEADERType|null
     */
    public function getREQUEST_HEADER()
    {
        return $this->REQUEST_HEADER;
    }
    /**
     * Set REQUEST_HEADER value
     * @param \StructType\REQUEST_HEADERType $rEQUEST_HEADER
     * @return \StructType\EArchiveInvoiceCountRequest
     */
    public function setREQUEST_HEADER(\StructType\REQUEST_HEADERType $rEQUEST_HEADER = null)
    {
        $this->REQUEST_HEADER = $rEQUEST_HEADER;
        return $this;
    }
    /**
     * Get ISSUE_DATE_START value
     * @return string|null
     */
    public function getISSUE_DATE_START()
    {
        return $this->ISSUE_DATE_START;
    }
    /**
     * Set ISSUE_DATE_START value
     * @param string $iSSUE_DATE_START
     * @return \StructType\EArchiveInvoiceCountRequest
     */
    public function setISSUE_DATE_START($iSSUE_DATE_START = null)
    {
        // validation for constraint: string
        if (!is_null($iSSUE_DATE_START) && !is_string($iSSUE_DATE_START)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($iSSUE_DATE_START)), __LINE__);
        }
        $this->ISSUE_DATE_START = $iSSUE_DATE_START;
        return $this;
    }
    /**
     * Get ISSUE_DATE_END value
     * @return string|null
     */
    public function getISSUE_DATE_END()
    {
        return $this->ISSUE_DATE_END;
    }
    /**
     * Set ISSUE_DATE_END value
     * @param string $iSSUE_DATE_END
     * @return \StructType\EArchiveInvoiceCountRequest
     */
    public function setISSUE_DATE_END($iSSUE_DATE_END = null)
    {
        // validation for constraint: string
        if (!is_null($iSSUE_DATE_END) && !is_string($iSSUE_DATE_END)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($iSSUE_DATE_END)), __LINE__);
        }
        $this->ISSUE_DATE_END = $iSSUE_DATE_END;
        return $this;
    }
    /**
     * Get CDATE_START value
     * @return string|null
     */
    public function getCDATE_START()
    {
        return $this->CDATE_START;
    }
    /**
     * Set CDATE_START value
     * @param string $cDATE_START
     * @return \StructType\EArchiveInvoiceCountRequest
     */
    public function setCDATE_START($cDATE_START = null)
    {
        // validation for constraint: string
        if (!is_null($cDATE_START) && !is_string($cDATE_START)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cDATE_START)), __LINE__);
        }
        $this->CDATE_START = $cDATE_START;
        return $this;
    }
    /**
     * Get CDATE_END value
     * @return string|null
     */
    public function getCDATE_END()
    {
        return $this->CDATE_END;
    }
    /**
     * Set CDATE_END value
     * @param string $cDATE_END
     * @return \StructType\EArchiveInvoiceCountRequest
     */
    public function setCDATE_END($cDATE_END = null)
    {
        // validation for constraint: string
        if (!is_null($cDATE_END) && !is_string($cDATE_END)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cDATE_END)), __LINE__);
        }
        $this->CDATE_END = $cDATE_END;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\EArchiveInvoiceCountRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
