<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ENTITYType StructType
 * Meta informations extracted from the WSDL
 * - documentation: Helper Entity; defines basic properties for a business entity
 * @subpackage Structs
 */
class ENTITYType extends ENTITYBaseType
{
    /**
     * The FILESET
     * Meta informations extracted from the WSDL
     * - documentation: See FILESET type
     * - minOccurs: 0
     * @var \StructType\FILESETType
     */
    public $FILESET;
    /**
     * The COMMENTSET
     * Meta informations extracted from the WSDL
     * - documentation: See COMMENTSET type
     * - minOccurs: 0
     * @var \StructType\COMMENTSETType
     */
    public $COMMENTSET;
    /**
     * Constructor method for ENTITYType
     * @uses ENTITYType::setFILESET()
     * @uses ENTITYType::setCOMMENTSET()
     * @param \StructType\FILESETType $fILESET
     * @param \StructType\COMMENTSETType $cOMMENTSET
     */
    public function __construct(\StructType\FILESETType $fILESET = null, \StructType\COMMENTSETType $cOMMENTSET = null)
    {
        $this
            ->setFILESET($fILESET)
            ->setCOMMENTSET($cOMMENTSET);
    }
    /**
     * Get FILESET value
     * @return \StructType\FILESETType|null
     */
    public function getFILESET()
    {
        return $this->FILESET;
    }
    /**
     * Set FILESET value
     * @param \StructType\FILESETType $fILESET
     * @return \StructType\ENTITYType
     */
    public function setFILESET(\StructType\FILESETType $fILESET = null)
    {
        $this->FILESET = $fILESET;
        return $this;
    }
    /**
     * Get COMMENTSET value
     * @return \StructType\COMMENTSETType|null
     */
    public function getCOMMENTSET()
    {
        return $this->COMMENTSET;
    }
    /**
     * Set COMMENTSET value
     * @param \StructType\COMMENTSETType $cOMMENTSET
     * @return \StructType\ENTITYType
     */
    public function setCOMMENTSET(\StructType\COMMENTSETType $cOMMENTSET = null)
    {
        $this->COMMENTSET = $cOMMENTSET;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ENTITYType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
