<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GenericReadResponse StructType
 * Meta informations extracted from the WSDL
 * - type: GenericReadResponse
 * @subpackage Structs
 */
class GenericReadResponse extends AbstractStructBase
{
    /**
     * The GEN_ARCHIVE_DOC
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Base64Binary[]
     */
    public $GEN_ARCHIVE_DOC;
    /**
     * The REQUEST_RETURN
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\REQUEST_RETURNType
     */
    public $REQUEST_RETURN;
    /**
     * The ERROR_TYPE
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\REQUEST_ERRORType
     */
    public $ERROR_TYPE;
    /**
     * Constructor method for GenericReadResponse
     * @uses GenericReadResponse::setGEN_ARCHIVE_DOC()
     * @uses GenericReadResponse::setREQUEST_RETURN()
     * @uses GenericReadResponse::setERROR_TYPE()
     * @param \StructType\Base64Binary[] $gEN_ARCHIVE_DOC
     * @param \StructType\REQUEST_RETURNType $rEQUEST_RETURN
     * @param \StructType\REQUEST_ERRORType $eRROR_TYPE
     */
    public function __construct(array $gEN_ARCHIVE_DOC = array(), \StructType\REQUEST_RETURNType $rEQUEST_RETURN = null, \StructType\REQUEST_ERRORType $eRROR_TYPE = null)
    {
        $this
            ->setGEN_ARCHIVE_DOC($gEN_ARCHIVE_DOC)
            ->setREQUEST_RETURN($rEQUEST_RETURN)
            ->setERROR_TYPE($eRROR_TYPE);
    }
    /**
     * Get GEN_ARCHIVE_DOC value
     * @return \StructType\Base64Binary[]|null
     */
    public function getGEN_ARCHIVE_DOC()
    {
        return $this->GEN_ARCHIVE_DOC;
    }
    /**
     * Set GEN_ARCHIVE_DOC value
     * @throws \InvalidArgumentException
     * @param \StructType\Base64Binary[] $gEN_ARCHIVE_DOC
     * @return \StructType\GenericReadResponse
     */
    public function setGEN_ARCHIVE_DOC(array $gEN_ARCHIVE_DOC = array())
    {
        foreach ($gEN_ARCHIVE_DOC as $genericReadResponseGEN_ARCHIVE_DOCItem) {
            // validation for constraint: itemType
            if (!$genericReadResponseGEN_ARCHIVE_DOCItem instanceof \StructType\Base64Binary) {
                throw new \InvalidArgumentException(sprintf('The GEN_ARCHIVE_DOC property can only contain items of \StructType\Base64Binary, "%s" given', is_object($genericReadResponseGEN_ARCHIVE_DOCItem) ? get_class($genericReadResponseGEN_ARCHIVE_DOCItem) : gettype($genericReadResponseGEN_ARCHIVE_DOCItem)), __LINE__);
            }
        }
        $this->GEN_ARCHIVE_DOC = $gEN_ARCHIVE_DOC;
        return $this;
    }
    /**
     * Add item to GEN_ARCHIVE_DOC value
     * @throws \InvalidArgumentException
     * @param \StructType\Base64Binary $item
     * @return \StructType\GenericReadResponse
     */
    public function addToGEN_ARCHIVE_DOC(\StructType\Base64Binary $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Base64Binary) {
            throw new \InvalidArgumentException(sprintf('The GEN_ARCHIVE_DOC property can only contain items of \StructType\Base64Binary, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->GEN_ARCHIVE_DOC[] = $item;
        return $this;
    }
    /**
     * Get REQUEST_RETURN value
     * @return \StructType\REQUEST_RETURNType|null
     */
    public function getREQUEST_RETURN()
    {
        return $this->REQUEST_RETURN;
    }
    /**
     * Set REQUEST_RETURN value
     * @param \StructType\REQUEST_RETURNType $rEQUEST_RETURN
     * @return \StructType\GenericReadResponse
     */
    public function setREQUEST_RETURN(\StructType\REQUEST_RETURNType $rEQUEST_RETURN = null)
    {
        $this->REQUEST_RETURN = $rEQUEST_RETURN;
        return $this;
    }
    /**
     * Get ERROR_TYPE value
     * @return \StructType\REQUEST_ERRORType|null
     */
    public function getERROR_TYPE()
    {
        return $this->ERROR_TYPE;
    }
    /**
     * Set ERROR_TYPE value
     * @param \StructType\REQUEST_ERRORType $eRROR_TYPE
     * @return \StructType\GenericReadResponse
     */
    public function setERROR_TYPE(\StructType\REQUEST_ERRORType $eRROR_TYPE = null)
    {
        $this->ERROR_TYPE = $eRROR_TYPE;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GenericReadResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
