<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetEArchiveReportRequest StructType
 * Meta informations extracted from the WSDL
 * - type: GetEArchiveReportRequest
 * @subpackage Structs
 */
class GetEArchiveReportRequest extends AbstractStructBase
{
    /**
     * The REQUEST_HEADER
     * @var \StructType\REQUEST_HEADERType
     */
    public $REQUEST_HEADER;
    /**
     * The REPORT_PERIOD
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $REPORT_PERIOD;
    /**
     * The REPORT_STATUS_FLAG
     * Meta informations extracted from the WSDL
     * - default: N
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $REPORT_STATUS_FLAG;
    /**
     * The START_DATE
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $START_DATE;
    /**
     * The END_DATE
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $END_DATE;
    /**
     * Constructor method for GetEArchiveReportRequest
     * @uses GetEArchiveReportRequest::setREQUEST_HEADER()
     * @uses GetEArchiveReportRequest::setREPORT_PERIOD()
     * @uses GetEArchiveReportRequest::setREPORT_STATUS_FLAG()
     * @uses GetEArchiveReportRequest::setSTART_DATE()
     * @uses GetEArchiveReportRequest::setEND_DATE()
     * @param \StructType\REQUEST_HEADERType $rEQUEST_HEADER
     * @param string $rEPORT_PERIOD
     * @param string $rEPORT_STATUS_FLAG
     * @param string $sTART_DATE
     * @param string $eND_DATE
     */
    public function __construct(\StructType\REQUEST_HEADERType $rEQUEST_HEADER = null, $rEPORT_PERIOD = null, $rEPORT_STATUS_FLAG = 'N', $sTART_DATE = null, $eND_DATE = null)
    {
        $this
            ->setREQUEST_HEADER($rEQUEST_HEADER)
            ->setREPORT_PERIOD($rEPORT_PERIOD)
            ->setREPORT_STATUS_FLAG($rEPORT_STATUS_FLAG)
            ->setSTART_DATE($sTART_DATE)
            ->setEND_DATE($eND_DATE);
    }
    /**
     * Get REQUEST_HEADER value
     * @return \StructType\REQUEST_HEADERType|null
     */
    public function getREQUEST_HEADER()
    {
        return $this->REQUEST_HEADER;
    }
    /**
     * Set REQUEST_HEADER value
     * @param \StructType\REQUEST_HEADERType $rEQUEST_HEADER
     * @return \StructType\GetEArchiveReportRequest
     */
    public function setREQUEST_HEADER(\StructType\REQUEST_HEADERType $rEQUEST_HEADER = null)
    {
        $this->REQUEST_HEADER = $rEQUEST_HEADER;
        return $this;
    }
    /**
     * Get REPORT_PERIOD value
     * @return string|null
     */
    public function getREPORT_PERIOD()
    {
        return $this->REPORT_PERIOD;
    }
    /**
     * Set REPORT_PERIOD value
     * @param string $rEPORT_PERIOD
     * @return \StructType\GetEArchiveReportRequest
     */
    public function setREPORT_PERIOD($rEPORT_PERIOD = null)
    {
        // validation for constraint: string
        if (!is_null($rEPORT_PERIOD) && !is_string($rEPORT_PERIOD)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($rEPORT_PERIOD)), __LINE__);
        }
        $this->REPORT_PERIOD = $rEPORT_PERIOD;
        return $this;
    }
    /**
     * Get REPORT_STATUS_FLAG value
     * @return string|null
     */
    public function getREPORT_STATUS_FLAG()
    {
        return $this->REPORT_STATUS_FLAG;
    }
    /**
     * Set REPORT_STATUS_FLAG value
     * @param string $rEPORT_STATUS_FLAG
     * @return \StructType\GetEArchiveReportRequest
     */
    public function setREPORT_STATUS_FLAG($rEPORT_STATUS_FLAG = 'N')
    {
        // validation for constraint: string
        if (!is_null($rEPORT_STATUS_FLAG) && !is_string($rEPORT_STATUS_FLAG)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($rEPORT_STATUS_FLAG)), __LINE__);
        }
        $this->REPORT_STATUS_FLAG = $rEPORT_STATUS_FLAG;
        return $this;
    }
    /**
     * Get START_DATE value
     * @return string|null
     */
    public function getSTART_DATE()
    {
        return $this->START_DATE;
    }
    /**
     * Set START_DATE value
     * @param string $sTART_DATE
     * @return \StructType\GetEArchiveReportRequest
     */
    public function setSTART_DATE($sTART_DATE = null)
    {
        // validation for constraint: string
        if (!is_null($sTART_DATE) && !is_string($sTART_DATE)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($sTART_DATE)), __LINE__);
        }
        $this->START_DATE = $sTART_DATE;
        return $this;
    }
    /**
     * Get END_DATE value
     * @return string|null
     */
    public function getEND_DATE()
    {
        return $this->END_DATE;
    }
    /**
     * Set END_DATE value
     * @param string $eND_DATE
     * @return \StructType\GetEArchiveReportRequest
     */
    public function setEND_DATE($eND_DATE = null)
    {
        // validation for constraint: string
        if (!is_null($eND_DATE) && !is_string($eND_DATE)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($eND_DATE)), __LINE__);
        }
        $this->END_DATE = $eND_DATE;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetEArchiveReportRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
