<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for REQUEST_INFOType StructType
 * Meta informations extracted from the WSDL
 * - documentation: Detailed Information about the status of a request
 * @subpackage Structs
 */
class REQUEST_INFOType extends AbstractStructBase
{
    /**
     * The REQUEST_HEADER
     * Meta informations extracted from the WSDL
     * - documentation: See REQUEST_HEADER type
     * @var \StructType\REQUEST_HEADERType
     */
    public $REQUEST_HEADER;
    /**
     * The REQUEST_RETURN
     * Meta informations extracted from the WSDL
     * - documentation: See REQUEST_RETURNType
     * - minOccurs: 0
     * @var \StructType\REQUEST_RETURNType
     */
    public $REQUEST_RETURN;
    /**
     * The REQUEST_ERROR
     * Meta informations extracted from the WSDL
     * - documentation: See REQUEST_ERRORType
     * - minOccurs: 0
     * @var \StructType\REQUEST_ERRORType
     */
    public $REQUEST_ERROR;
    /**
     * Constructor method for REQUEST_INFOType
     * @uses REQUEST_INFOType::setREQUEST_HEADER()
     * @uses REQUEST_INFOType::setREQUEST_RETURN()
     * @uses REQUEST_INFOType::setREQUEST_ERROR()
     * @param \StructType\REQUEST_HEADERType $rEQUEST_HEADER
     * @param \StructType\REQUEST_RETURNType $rEQUEST_RETURN
     * @param \StructType\REQUEST_ERRORType $rEQUEST_ERROR
     */
    public function __construct(\StructType\REQUEST_HEADERType $rEQUEST_HEADER = null, \StructType\REQUEST_RETURNType $rEQUEST_RETURN = null, \StructType\REQUEST_ERRORType $rEQUEST_ERROR = null)
    {
        $this
            ->setREQUEST_HEADER($rEQUEST_HEADER)
            ->setREQUEST_RETURN($rEQUEST_RETURN)
            ->setREQUEST_ERROR($rEQUEST_ERROR);
    }
    /**
     * Get REQUEST_HEADER value
     * @return \StructType\REQUEST_HEADERType|null
     */
    public function getREQUEST_HEADER()
    {
        return $this->REQUEST_HEADER;
    }
    /**
     * Set REQUEST_HEADER value
     * @param \StructType\REQUEST_HEADERType $rEQUEST_HEADER
     * @return \StructType\REQUEST_INFOType
     */
    public function setREQUEST_HEADER(\StructType\REQUEST_HEADERType $rEQUEST_HEADER = null)
    {
        $this->REQUEST_HEADER = $rEQUEST_HEADER;
        return $this;
    }
    /**
     * Get REQUEST_RETURN value
     * @return \StructType\REQUEST_RETURNType|null
     */
    public function getREQUEST_RETURN()
    {
        return $this->REQUEST_RETURN;
    }
    /**
     * Set REQUEST_RETURN value
     * @param \StructType\REQUEST_RETURNType $rEQUEST_RETURN
     * @return \StructType\REQUEST_INFOType
     */
    public function setREQUEST_RETURN(\StructType\REQUEST_RETURNType $rEQUEST_RETURN = null)
    {
        $this->REQUEST_RETURN = $rEQUEST_RETURN;
        return $this;
    }
    /**
     * Get REQUEST_ERROR value
     * @return \StructType\REQUEST_ERRORType|null
     */
    public function getREQUEST_ERROR()
    {
        return $this->REQUEST_ERROR;
    }
    /**
     * Set REQUEST_ERROR value
     * @param \StructType\REQUEST_ERRORType $rEQUEST_ERROR
     * @return \StructType\REQUEST_INFOType
     */
    public function setREQUEST_ERROR(\StructType\REQUEST_ERRORType $rEQUEST_ERROR = null)
    {
        $this->REQUEST_ERROR = $rEQUEST_ERROR;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\REQUEST_INFOType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
