<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SigPolicyQualifiersListType StructType
 * @subpackage Structs
 */
class SigPolicyQualifiersListType extends AbstractStructBase
{
    /**
     * The SigPolicyQualifier
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\AnyType[]
     */
    public $SigPolicyQualifier;
    /**
     * Constructor method for SigPolicyQualifiersListType
     * @uses SigPolicyQualifiersListType::setSigPolicyQualifier()
     * @param \StructType\AnyType[] $sigPolicyQualifier
     */
    public function __construct(array $sigPolicyQualifier = array())
    {
        $this
            ->setSigPolicyQualifier($sigPolicyQualifier);
    }
    /**
     * Get SigPolicyQualifier value
     * @return \StructType\AnyType[]|null
     */
    public function getSigPolicyQualifier()
    {
        return $this->SigPolicyQualifier;
    }
    /**
     * Set SigPolicyQualifier value
     * @throws \InvalidArgumentException
     * @param \StructType\AnyType[] $sigPolicyQualifier
     * @return \StructType\SigPolicyQualifiersListType
     */
    public function setSigPolicyQualifier(array $sigPolicyQualifier = array())
    {
        foreach ($sigPolicyQualifier as $sigPolicyQualifiersListTypeSigPolicyQualifierItem) {
            // validation for constraint: itemType
            if (!$sigPolicyQualifiersListTypeSigPolicyQualifierItem instanceof \StructType\AnyType) {
                throw new \InvalidArgumentException(sprintf('The SigPolicyQualifier property can only contain items of \StructType\AnyType, "%s" given', is_object($sigPolicyQualifiersListTypeSigPolicyQualifierItem) ? get_class($sigPolicyQualifiersListTypeSigPolicyQualifierItem) : gettype($sigPolicyQualifiersListTypeSigPolicyQualifierItem)), __LINE__);
            }
        }
        $this->SigPolicyQualifier = $sigPolicyQualifier;
        return $this;
    }
    /**
     * Add item to SigPolicyQualifier value
     * @throws \InvalidArgumentException
     * @param \StructType\AnyType $item
     * @return \StructType\SigPolicyQualifiersListType
     */
    public function addToSigPolicyQualifier(\StructType\AnyType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AnyType) {
            throw new \InvalidArgumentException(sprintf('The SigPolicyQualifier property can only contain items of \StructType\AnyType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->SigPolicyQualifier[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SigPolicyQualifiersListType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
