<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SignaturePolicyIdType StructType
 * @subpackage Structs
 */
class SignaturePolicyIdType extends AbstractStructBase
{
    /**
     * The SigPolicyId
     * @var \StructType\ObjectIdentifierType
     */
    public $SigPolicyId;
    /**
     * The Transforms
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - ref: ds:Transforms
     * @var \StructType\TransformsType
     */
    public $Transforms;
    /**
     * The SigPolicyHash
     * @var \StructType\DigestAlgAndValueType
     */
    public $SigPolicyHash;
    /**
     * The SigPolicyQualifiers
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SigPolicyQualifiersListType
     */
    public $SigPolicyQualifiers;
    /**
     * Constructor method for SignaturePolicyIdType
     * @uses SignaturePolicyIdType::setSigPolicyId()
     * @uses SignaturePolicyIdType::setTransforms()
     * @uses SignaturePolicyIdType::setSigPolicyHash()
     * @uses SignaturePolicyIdType::setSigPolicyQualifiers()
     * @param \StructType\ObjectIdentifierType $sigPolicyId
     * @param \StructType\TransformsType $transforms
     * @param \StructType\DigestAlgAndValueType $sigPolicyHash
     * @param \StructType\SigPolicyQualifiersListType $sigPolicyQualifiers
     */
    public function __construct(\StructType\ObjectIdentifierType $sigPolicyId = null, \StructType\TransformsType $transforms = null, \StructType\DigestAlgAndValueType $sigPolicyHash = null, \StructType\SigPolicyQualifiersListType $sigPolicyQualifiers = null)
    {
        $this
            ->setSigPolicyId($sigPolicyId)
            ->setTransforms($transforms)
            ->setSigPolicyHash($sigPolicyHash)
            ->setSigPolicyQualifiers($sigPolicyQualifiers);
    }
    /**
     * Get SigPolicyId value
     * @return \StructType\ObjectIdentifierType|null
     */
    public function getSigPolicyId()
    {
        return $this->SigPolicyId;
    }
    /**
     * Set SigPolicyId value
     * @param \StructType\ObjectIdentifierType $sigPolicyId
     * @return \StructType\SignaturePolicyIdType
     */
    public function setSigPolicyId(\StructType\ObjectIdentifierType $sigPolicyId = null)
    {
        $this->SigPolicyId = $sigPolicyId;
        return $this;
    }
    /**
     * Get Transforms value
     * @return \StructType\TransformsType|null
     */
    public function getTransforms()
    {
        return $this->Transforms;
    }
    /**
     * Set Transforms value
     * @param \StructType\TransformsType $transforms
     * @return \StructType\SignaturePolicyIdType
     */
    public function setTransforms(\StructType\TransformsType $transforms = null)
    {
        $this->Transforms = $transforms;
        return $this;
    }
    /**
     * Get SigPolicyHash value
     * @return \StructType\DigestAlgAndValueType|null
     */
    public function getSigPolicyHash()
    {
        return $this->SigPolicyHash;
    }
    /**
     * Set SigPolicyHash value
     * @param \StructType\DigestAlgAndValueType $sigPolicyHash
     * @return \StructType\SignaturePolicyIdType
     */
    public function setSigPolicyHash(\StructType\DigestAlgAndValueType $sigPolicyHash = null)
    {
        $this->SigPolicyHash = $sigPolicyHash;
        return $this;
    }
    /**
     * Get SigPolicyQualifiers value
     * @return \StructType\SigPolicyQualifiersListType|null
     */
    public function getSigPolicyQualifiers()
    {
        return $this->SigPolicyQualifiers;
    }
    /**
     * Set SigPolicyQualifiers value
     * @param \StructType\SigPolicyQualifiersListType $sigPolicyQualifiers
     * @return \StructType\SignaturePolicyIdType
     */
    public function setSigPolicyQualifiers(\StructType\SigPolicyQualifiersListType $sigPolicyQualifiers = null)
    {
        $this->SigPolicyQualifiers = $sigPolicyQualifiers;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SignaturePolicyIdType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
