<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SignedPropertiesType StructType
 * @subpackage Structs
 */
class SignedPropertiesType extends AbstractStructBase
{
    /**
     * The SignedSignatureProperties
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SignedSignaturePropertiesType
     */
    public $SignedSignatureProperties;
    /**
     * The SignedDataObjectProperties
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SignedDataObjectPropertiesType
     */
    public $SignedDataObjectProperties;
    /**
     * The Id
     * Meta informations extracted from the WSDL
     * - use: optional
     * @var string
     */
    public $Id;
    /**
     * Constructor method for SignedPropertiesType
     * @uses SignedPropertiesType::setSignedSignatureProperties()
     * @uses SignedPropertiesType::setSignedDataObjectProperties()
     * @uses SignedPropertiesType::setId()
     * @param \StructType\SignedSignaturePropertiesType $signedSignatureProperties
     * @param \StructType\SignedDataObjectPropertiesType $signedDataObjectProperties
     * @param string $id
     */
    public function __construct(\StructType\SignedSignaturePropertiesType $signedSignatureProperties = null, \StructType\SignedDataObjectPropertiesType $signedDataObjectProperties = null, $id = null)
    {
        $this
            ->setSignedSignatureProperties($signedSignatureProperties)
            ->setSignedDataObjectProperties($signedDataObjectProperties)
            ->setId($id);
    }
    /**
     * Get SignedSignatureProperties value
     * @return \StructType\SignedSignaturePropertiesType|null
     */
    public function getSignedSignatureProperties()
    {
        return $this->SignedSignatureProperties;
    }
    /**
     * Set SignedSignatureProperties value
     * @param \StructType\SignedSignaturePropertiesType $signedSignatureProperties
     * @return \StructType\SignedPropertiesType
     */
    public function setSignedSignatureProperties(\StructType\SignedSignaturePropertiesType $signedSignatureProperties = null)
    {
        $this->SignedSignatureProperties = $signedSignatureProperties;
        return $this;
    }
    /**
     * Get SignedDataObjectProperties value
     * @return \StructType\SignedDataObjectPropertiesType|null
     */
    public function getSignedDataObjectProperties()
    {
        return $this->SignedDataObjectProperties;
    }
    /**
     * Set SignedDataObjectProperties value
     * @param \StructType\SignedDataObjectPropertiesType $signedDataObjectProperties
     * @return \StructType\SignedPropertiesType
     */
    public function setSignedDataObjectProperties(\StructType\SignedDataObjectPropertiesType $signedDataObjectProperties = null)
    {
        $this->SignedDataObjectProperties = $signedDataObjectProperties;
        return $this;
    }
    /**
     * Get Id value
     * @return string|null
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param string $id
     * @return \StructType\SignedPropertiesType
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($id)), __LINE__);
        }
        $this->Id = $id;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SignedPropertiesType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
