<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for tuzelKisi StructType
 * @subpackage Structs
 */
class TuzelKisi extends AbstractStructBase
{
    /**
     * The vkn
     * Meta informations extracted from the WSDL
     * - pattern: \d\d\d\d\d\d\d\d\d\d
     * @var string
     */
    public $vkn;
    /**
     * The unvan
     * Meta informations extracted from the WSDL
     * - minLength: 2
     * @var string
     */
    public $unvan;
    /**
     * Constructor method for tuzelKisi
     * @uses TuzelKisi::setVkn()
     * @uses TuzelKisi::setUnvan()
     * @param string $vkn
     * @param string $unvan
     */
    public function __construct($vkn = null, $unvan = null)
    {
        $this
            ->setVkn($vkn)
            ->setUnvan($unvan);
    }
    /**
     * Get vkn value
     * @return string|null
     */
    public function getVkn()
    {
        return $this->vkn;
    }
    /**
     * Set vkn value
     * @param string $vkn
     * @return \StructType\TuzelKisi
     */
    public function setVkn($vkn = null)
    {
        // validation for constraint: pattern
        if (is_scalar($vkn) && !preg_match('/\\d\\d\\d\\d\\d\\d\\d\\d\\d\\d/', $vkn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a scalar value that matches "\d\d\d\d\d\d\d\d\d\d", "%s" given', var_export($vkn, true)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($vkn) && !is_string($vkn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($vkn)), __LINE__);
        }
        $this->vkn = $vkn;
        return $this;
    }
    /**
     * Get unvan value
     * @return string|null
     */
    public function getUnvan()
    {
        return $this->unvan;
    }
    /**
     * Set unvan value
     * @param string $unvan
     * @return \StructType\TuzelKisi
     */
    public function setUnvan($unvan = null)
    {
        // validation for constraint: minLength
        if ((is_scalar($unvan) && strlen($unvan) < 2) || (is_array($unvan) && count($unvan) < 2)) {
            throw new \InvalidArgumentException('Invalid length, please provide an array with 2 element(s) or a scalar of 2 character(s) at least', __LINE__);
        }
        // validation for constraint: string
        if (!is_null($unvan) && !is_string($unvan)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($unvan)), __LINE__);
        }
        $this->unvan = $unvan;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TuzelKisi
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
