<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UnsignedPropertiesType StructType
 * @subpackage Structs
 */
class UnsignedPropertiesType extends AbstractStructBase
{
    /**
     * The UnsignedSignatureProperties
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\UnsignedSignaturePropertiesType
     */
    public $UnsignedSignatureProperties;
    /**
     * The UnsignedDataObjectProperties
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\UnsignedDataObjectPropertiesType
     */
    public $UnsignedDataObjectProperties;
    /**
     * The Id
     * Meta informations extracted from the WSDL
     * - use: optional
     * @var string
     */
    public $Id;
    /**
     * Constructor method for UnsignedPropertiesType
     * @uses UnsignedPropertiesType::setUnsignedSignatureProperties()
     * @uses UnsignedPropertiesType::setUnsignedDataObjectProperties()
     * @uses UnsignedPropertiesType::setId()
     * @param \StructType\UnsignedSignaturePropertiesType $unsignedSignatureProperties
     * @param \StructType\UnsignedDataObjectPropertiesType $unsignedDataObjectProperties
     * @param string $id
     */
    public function __construct(\StructType\UnsignedSignaturePropertiesType $unsignedSignatureProperties = null, \StructType\UnsignedDataObjectPropertiesType $unsignedDataObjectProperties = null, $id = null)
    {
        $this
            ->setUnsignedSignatureProperties($unsignedSignatureProperties)
            ->setUnsignedDataObjectProperties($unsignedDataObjectProperties)
            ->setId($id);
    }
    /**
     * Get UnsignedSignatureProperties value
     * @return \StructType\UnsignedSignaturePropertiesType|null
     */
    public function getUnsignedSignatureProperties()
    {
        return $this->UnsignedSignatureProperties;
    }
    /**
     * Set UnsignedSignatureProperties value
     * @param \StructType\UnsignedSignaturePropertiesType $unsignedSignatureProperties
     * @return \StructType\UnsignedPropertiesType
     */
    public function setUnsignedSignatureProperties(\StructType\UnsignedSignaturePropertiesType $unsignedSignatureProperties = null)
    {
        $this->UnsignedSignatureProperties = $unsignedSignatureProperties;
        return $this;
    }
    /**
     * Get UnsignedDataObjectProperties value
     * @return \StructType\UnsignedDataObjectPropertiesType|null
     */
    public function getUnsignedDataObjectProperties()
    {
        return $this->UnsignedDataObjectProperties;
    }
    /**
     * Set UnsignedDataObjectProperties value
     * @param \StructType\UnsignedDataObjectPropertiesType $unsignedDataObjectProperties
     * @return \StructType\UnsignedPropertiesType
     */
    public function setUnsignedDataObjectProperties(\StructType\UnsignedDataObjectPropertiesType $unsignedDataObjectProperties = null)
    {
        $this->UnsignedDataObjectProperties = $unsignedDataObjectProperties;
        return $this;
    }
    /**
     * Get Id value
     * @return string|null
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param string $id
     * @return \StructType\UnsignedPropertiesType
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($id)), __LINE__);
        }
        $this->Id = $id;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UnsignedPropertiesType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
